function getChartDeals() {

	let ctx = $('#chartDeals');

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										},
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label = context.parsed.y.toFixed(2) + '%';
																}
																	
																return label;
															}
														}
										},
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 5,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														return (Math.round(value * 100) / 100).toFixed(2) + '%';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartVolatility_old() {

	let ctx = $('#chartVolatilityPerc');

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								title: {
											display: true,
											text: 'Top 24h Volatility',
											color: '#cdcdcd',
											font: { weight: 'bold', size: '14px' },
											padding: {
														top: 0,
														bottom: 0
													 }
								},
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label = context.parsed.y + '%';
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 5,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														return (Math.round(value)).toFixed(2) + '%';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartVolatility() {

	let ctx = $('#chartVolatilityPerc');

	let defaultLegendClickHandler = Chart.defaults.plugins.legend.onClick;

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								title: {
											display: true,
											text: '',
											color: '#cdcdcd',
											font: { weight: 'bold', size: '14px' },
											padding: {
														top: 0,
														bottom: 0
													 }
								},
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label = numFormatter(context.parsed.y);
																	//label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}

																if (context.datasetIndex == 0 || context.datasetIndex == 1) {

																	label += '%';
																}

																return label;
															}
														}
										},
								legend: {
											display: true,
											position: 'top',
											onClick: function(e, legendItem, legend) {

												//let text = legendItem.text.toUpperCase();

												// Default legend handler
												const index = legendItem.datasetIndex;
												const ci = legend.chart;

												if (ci.isDatasetVisible(index)) {

													ci.hide(index);
													legendItem.hidden = true;

												} else {

													ci.show(index);
													legendItem.hidden = false;
												}
            
												ci.update();
											},
											labels: {
														color: '#cdcdcd',
														usePointStyle: false,
														boxWidth: 20,
														padding: 20,
														//filter: function(item, data) {

															//alert(JSON.stringify(data));
															//return item;
														//}
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip: false,
													min: 1,
													stepSize: 5,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//min: 200000,
										//max: 1000000000,
										ticks: {
													display: true,
													autoSkip: true,
													//min: 1,
													stepSize: 1,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														//return value / 1e6 + 'M';
														return (Math.round(value)).toFixed(2);
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartPairs() {

	let ctx = $('#chartPairs');

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 10,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														return '$' + (Math.round(value * 100) / 100).toFixed(2);
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartPairsMini(id) {

	let ctx = $('#' + id);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1,
								pointRadius: 1,
								pointStyle: 'rect'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										grid: {
												display: false
										},
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: .5,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										grid: {
												display: false
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: .5,
													color: '#cdcdcd',
													callback: function(value, index, values) {

														//return '$' + (Math.round(value * 100) / 100).toFixed(4);
														return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartVolScores() {

	let ctx = $('#chartVolScores');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['volatility_score_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								borderColor: [ globalConfig['colors']['charts']['volatility_score_color'] ],
								fill: 'start',
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['volatility_score_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										ticks: {
													display: true,
													autoSkip : true,
													maxTicksLimit: 15,
													stepSize: 0.25,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
											   }
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 0.20,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return value.toFixed(2);
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartVolume() {

	let ctx = $('#chartHoverVolume');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['volume_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								borderColor: [ globalConfig['colors']['charts']['volume_color'] ],
								fill: 'start',
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['volume_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										afterBuildTicks: function(axis) {

											let values = axis.ticks.map(t => t.value);
											
											axis.ticks = [];
																					
											for (let i = 0; i < values.length; i++) {
												
												let v = values[i];
												
												let obj = { 'value': v };
												axis.ticks.push(obj);
											}
										},  
										ticks: {
													display: true,
													autoSkip: false,
													//maxTicksLimit: 15,
													min: 1,
													stepSize: 10,
													color: globalConfig['colors']['charts']['ticks_color'],
													major: {
																enabled: true
													},
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														let total = values.length;
														let content = this.getLabelForValue(value);
														return content;

														/*
														// Start displaying after n values so last label will display
														// Set autoSkip: true to work properly

														if (total > 10) {

															if (index % 2 === 0) {

																return content;
															}
															else if (index == (total - 1)) {

																return content;
															}
														}
														else {
															
															return content;
														}
														*/
													},
												},
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										//max: 1000000000,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													//min: 1,
													//stepSize: 10000000,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return numFormatter(value);
														//return (value < 1000000) ? value / 1000 + 'k' : value / 1000000 + 'M';
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartTrendScores() {

	let ctx = $('#chartTrendScores');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['price_action_score_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								borderColor: [ globalConfig['colors']['charts']['price_action_score_color'] ],
								fill: 'start',
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['price_action_score_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										ticks: {
													display: true,
													autoSkip : true,
													maxTicksLimit: 15,
													stepSize: 0.25,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
											   }
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 0.20,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return value.toFixed(2);
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartTrendRsi() {

	let ctx = $('#chartTrendRsi');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['rsi14_15m_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								borderColor: [ globalConfig['colors']['charts']['rsi14_15m_color'] ],
								fill: 'start',
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['rsi14_15m_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										ticks: {
													display: true,
													autoSkip : true,
													maxTicksLimit: 15,
													stepSize: 0.25,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
											   }
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										reverse: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 1,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return value.toFixed(0);
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartSymRank() {

	let ctx = $('#chartSymRank');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['sym_rank_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								fill: 'start',
								borderColor: [ globalConfig['colors']['charts']['sym_rank_color'] ],
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['sym_rank_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										ticks: {
													display: true,
													autoSkip : true,
													maxTicksLimit: 15,
													stepSize: 0.25,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
											   }
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										reverse: true,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 1,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return value.toFixed(0);
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartSymScore() {

	let ctx = $('#chartSymScore');

	let bgColorRGB = hexToRgbA(globalConfig['colors']['charts']['sym_score_color'], globalConfig['colors']['charts']['alpha']);

	let chart = new Chart(ctx, {

		type: 'line',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [ bgColorRGB ],
								borderColor: [ globalConfig['colors']['charts']['sym_score_color'] ],
								fill: 'start',
								borderWidth: 1,
								pointRadius: 3,
								pointBackgroundColor: globalConfig['colors']['charts']['sym_score_color'],
								pointBorderColor: '#000000',
								pointStyle: 'circle'
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										ticks: {
													display: true,
													autoSkip : true,
													maxTicksLimit: 15,
													stepSize: 0.25,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
											   }
								   },
								y: {
										beginAtZero: false,
										type: 'linear',
										reverse: false,
										grid: {
												display: true,
												color: globalConfig['colors']['charts']['grid_color']
										},
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 1,
													color: globalConfig['colors']['charts']['ticks_color'],
													font: function(context) {
																				let width = context.chart.width;
																				let size = Math.round(width / globalConfig['colors']['charts']['font_divisor']);

																				return {
																							//weight: 'bold',
																							size: size
																					   };
													},
													callback: function(value, index, values) {

														return value.toFixed(0);
														//return '';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartHistory() {

	let ctx = $('#chartHistory');

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 10,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														return '$' + (Math.round(value * 100) / 100).toFixed(2);
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartDailyProfit() {

	let ctx = $('#chartDailyProfit');

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								barPercentage: .9,
								minBarLength: 15,
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: false,
											position: 'top',
											labels: {
														color: '#000000',
														usePointStyle: false,
														boxWidth: 20,
														padding: 0
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip : false,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//max: 25,
										ticks: {
													display: true,
													autoSkip : true,
													stepSize: 5,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														return '$' + (Math.round(value * 100) / 100).toFixed(2);
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function getChartMarkets() {

	let ctx = $('#chartMarkets');

	let defaultLegendClickHandler = Chart.defaults.plugins.legend.onClick;

	let chart = new Chart(ctx, {

		type: 'bar',
		data: {
				datasets: [{
								label: [],
								data: [],
								backgroundColor: [],
								borderColor: [],
								borderWidth: 1
						  }]
		},
		options: {
					responsive: true,
					maintainAspectRatio: false,
					plugins: {
								title: {
											display: true,
											text: 'Top 24h Volume',
											color: '#cdcdcd',
											font: { weight: 'bold', size: '14px' },
											padding: {
														top: 0,
														bottom: 0
													 }
								},
								tooltip: {
											callbacks: {
															label: function(context) {
																		
																let label = context.dataset.label || '';

																if (label) { label += ': '; }
																						
																if (context.parsed.y !== null) {

																	label = numFormatter(context.parsed.y);
																	//label += new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(context.parsed.y);
																}
																	
																return label;
															}
														}
										},
								legend: {
											display: true,
											position: 'top',
											onClick: function(e, legendItem, legend) {

												//let text = legendItem.text.toUpperCase();

												// Default legend handler
												const index = legendItem.datasetIndex;
												const ci = legend.chart;

												if (ci.isDatasetVisible(index)) {

													ci.hide(index);
													legendItem.hidden = true;

												} else {

													ci.show(index);
													legendItem.hidden = false;
												}
            
												ci.update();
											},
											labels: {
														color: '#cdcdcd',
														usePointStyle: false,
														boxWidth: 20,
														padding: 20,
														//filter: function(item, data) {

															//alert(JSON.stringify(data));
															//return item;
														//}
													}
										}
					},
					scales: {
								x: {
										beginAtZero: true,
										ticks: {
													display: true,
													autoSkip: false,
													min: 1,
													stepSize: 10,
													color: '#cdcdcd',
											   }
								   },
								y: {
										beginAtZero: true,
										type: 'linear',
										//min: 200000,
										max: 1000000000,
										ticks: {
													display: true,
													autoSkip: true,
													min: 1,
													stepSize: 1000000,
													color: '#cdcdcd',
													callback: function(value, index, values) {
							
														//return value / 1e6 + 'M';
														return (value < 1000000) ? value / 1000 + 'k' : value / 1000000 + 'M';
													}
											   }
								   }
							}
				}
	});

	return chart;
}


function updateChartTickColors(chart, ticksColor, gridColor) {

	chart.config.options.scales.x.grid.color = globalConfig['colors']['charts'][gridColor];
	chart.config.options.scales.y.grid.color = globalConfig['colors']['charts'][gridColor];

	chart.config.options.scales.x.ticks.color = globalConfig['colors']['charts'][ticksColor];
	chart.config.options.scales.y.ticks.color = globalConfig['colors']['charts'][ticksColor];

	//chart.update();
}


function addChartData(chart, label, data, colorRatio, colorSolid, colorKey) {

	let color1 = 'fc5048';
	let color2 = '489ffc';

	let hex = function(x) {

		x = x.toString(16);
		return (x.length == 1) ? '0' + x : x;
	}

	let dcData = JSON.parse(JSON.stringify(data));

	chart.data.labels.push(label);

    chart.data.datasets.forEach((dataset) => {

		dataset.data.push(dcData);

		let r = Math.ceil(parseInt(color1.substring(0,2), 16) * colorRatio + parseInt(color2.substring(0,2), 16) * (1 - colorRatio));
		let g = Math.ceil(parseInt(color1.substring(2,4), 16) * colorRatio + parseInt(color2.substring(2,4), 16) * (1 - colorRatio));
		let b = Math.ceil(parseInt(color1.substring(4,6), 16) * colorRatio + parseInt(color2.substring(4,6), 16) * (1 - colorRatio));

		let hexColor = hex(r) + hex(g) + hex(b);

		let color = hexColor;

		if (colorSolid != undefined && colorSolid != null && colorSolid != '') {

			color = colorSolid;
			color = color.replace('#', '');
		}

		if (colorKey != undefined && colorKey != null) {

			let bgColorRGB;
			let borderColor;
			let pointBorderColor;

			if (darkModeCharts) {

				bgColorRGB = hexToRgbA(globalConfig['colors']['charts'][colorKey], globalConfig['colors']['charts']['alpha']);
				borderColor = globalConfig['colors']['charts'][colorKey];
				pointBorderColor = borderColor;
			}
			else {

				bgColorRGB = hexToRgbA(globalConfig['colors']['charts'][colorKey], globalConfig['colors']['charts']['alpha_light']);
				borderColor = globalConfig['colors']['charts']['ticks_color_light'];
				pointBorderColor = borderColor;
			}

			dataset.backgroundColor = [ bgColorRGB ];
			dataset.borderColor = [ borderColor ];
			dataset.pointBorderColor = pointBorderColor;

			if (darkModeCharts) {

				updateChartTickColors(chart, 'ticks_color', 'grid_color');
			}
			else {

				updateChartTickColors(chart, 'ticks_color_light', 'grid_color_light');
			}
			
			bgColorRGB = null;
			borderColor = null;
			pointBorderColor = null;
		}
		else {

			dataset.backgroundColor.push('#' + color);
			dataset.borderColor.push('#000000');
		}

	});

	chart.update();

	dcData = null;
}


function removeChartData(chart) {

	let total = chart.data.labels.length;

	while (total >= 0) {

		chart.data.labels.pop();
		chart.data.datasets[0].data.pop();
		total--;
	}

	chart.update();

	return;
}

